"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ObjectionCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const objection_utils_1 = require("./objection.utils");
let ObjectionCoreModule = ObjectionCoreModule_1 = class ObjectionCoreModule {
    static forRoot(options, connection) {
        const objectionOptionsProvider = {
            provide: objection_utils_1.getObjectionOptionsToken(connection),
            useValue: options,
        };
        const objectionConnectionProvider = {
            provide: objection_utils_1.getObjectionConnectionToken(connection),
            useValue: objection_utils_1.createObjectionConnection(options),
        };
        return {
            module: ObjectionCoreModule_1,
            providers: [
                objectionOptionsProvider,
                objectionConnectionProvider,
            ],
            exports: [
                objectionOptionsProvider,
                objectionConnectionProvider,
            ],
        };
    }
    static forRootAsync(options, connection) {
        const objectionConnectionProvider = {
            provide: objection_utils_1.getObjectionConnectionToken(connection),
            useFactory(options) {
                return objection_utils_1.createObjectionConnection(options);
            },
            inject: [objection_utils_1.getObjectionOptionsToken(connection)],
        };
        return {
            module: ObjectionCoreModule_1,
            imports: options.imports,
            providers: [...this.createAsyncProviders(options, connection), objectionConnectionProvider],
            exports: [objectionConnectionProvider],
        };
    }
    static createAsyncProviders(options, connection) {
        if (!(options.useExisting || options.useFactory || options.useClass)) {
            throw new Error('Invalid configuration. Must provide useFactory, useClass or useExisting');
        }
        if (options.useExisting || options.useFactory) {
            return [
                this.createAsyncOptionsProvider(options, connection)
            ];
        }
        return [
            this.createAsyncOptionsProvider(options, connection),
            { provide: options.useClass, useClass: options.useClass },
        ];
    }
    static createAsyncOptionsProvider(options, connection) {
        if (!(options.useExisting || options.useFactory || options.useClass)) {
            throw new Error('Invalid configuration. Must provide useFactory, useClass or useExisting');
        }
        if (options.useFactory) {
            return {
                provide: objection_utils_1.getObjectionOptionsToken(connection),
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: objection_utils_1.getObjectionOptionsToken(connection),
            async useFactory(optionsFactory) {
                return await optionsFactory.createObjectionModuleOptions();
            },
            inject: [options.useClass || options.useExisting],
        };
    }
};
ObjectionCoreModule = ObjectionCoreModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({})
], ObjectionCoreModule);
exports.ObjectionCoreModule = ObjectionCoreModule;
