/// <reference path="objection.soft-delete.d.ts" />
import { Model, QueryBuilder, RelationMappings } from 'objection';
export * as knex from 'knex';
export { Model, QueryBuilder };
export declare function Table(options: Partial<typeof Model> & {
    softDelete?: boolean | string;
}): (target: any) => void;
export declare const columnTypes: {
    increments: {
        columnType: string;
        type: string[];
    };
    bigIncrements: {
        columnType: string;
        type: string[];
    };
    integer: {
        columnType: string;
        type: string[];
    };
    bigInteger: {
        columnType: string;
        type: string[];
    };
    text: {
        columnType: string;
        type: string[];
    };
    string: {
        columnType: string;
        type: string[];
    };
    float: {
        columnType: string;
        type: string[];
    };
    decimal: {
        columnType: string;
        type: string[];
    };
    boolean: {
        columnType: string;
        type: string[];
    };
    date: {
        columnType: string;
        type: string[];
    };
    datetime: {
        columnType: string;
        type: string[];
    };
    time: {
        columnType: string;
        type: string[];
    };
    timestamp: {
        columnType: string;
        type: string[];
    };
    timestamps: {
        columnType: string;
        type: string[];
    };
    binary: {
        columnType: string;
        type: string[];
    };
    json: {
        columnType: string;
        type: string[];
    };
    jsonb: {
        columnType: string;
        type: string[];
    };
    uuid: {
        columnType: string;
        type: string[];
    };
    number: {
        columnType: string;
        type: string[];
    };
    object: {
        columnType: string;
        type: string[];
    };
};
declare type ColumnOptions = {
    type: typeof columnTypes[keyof typeof columnTypes];
    columnName?: string;
    default?: any;
    nullable?: boolean;
    notNullable?: boolean;
    unique?: boolean;
    unsigned?: boolean;
    primary?: boolean;
};
export declare function Column(options?: ColumnOptions): (target: any, propertyKey: string) => void;
export declare const relationTypes: {
    readonly HasManyRelation: import("objection").RelationType;
    readonly HasOneRelation: import("objection").RelationType;
    readonly HasOneThroughRelation: import("objection").RelationType;
    readonly BelongsToOneRelation: import("objection").RelationType;
};
declare type RelationMappingItem = RelationMappings[''];
declare type RelationMappingsThunkItem = () => RelationMappingItem;
export declare function Relation(relationMapping: RelationMappingItem | RelationMappingsThunkItem): (target: any, propertyKey: string) => void;
export declare function synchronize(model: typeof Model, force?: boolean): Promise<void>;
