"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Knex = require("knex");
const objection_1 = require("objection");
const objection_constants_1 = require("./objection.constants");
function getObjectionOptionsToken(connection) {
    return `${connection || objection_constants_1.OBJECTION_MODULE_CONNECTION}_${objection_constants_1.OBJECTION_MODULE_OPTIONS_TOKEN}`;
}
exports.getObjectionOptionsToken = getObjectionOptionsToken;
function getObjectionConnectionToken(connection) {
    return `${connection || objection_constants_1.OBJECTION_MODULE_CONNECTION}_${objection_constants_1.OBJECTION_MODULE_CONNECTION_TOKEN}`;
}
exports.getObjectionConnectionToken = getObjectionConnectionToken;
function getObjectionBaseModelToken(connection) {
    return `${connection || objection_constants_1.OBJECTION_MODULE_CONNECTION}_${objection_constants_1.OBJECTION_MODULE_BASE_MODEL_TOKEN}`;
}
exports.getObjectionBaseModelToken = getObjectionBaseModelToken;
function getObjectionModelToken(model, connection) {
    return `${connection || objection_constants_1.OBJECTION_MODULE_CONNECTION}_${objection_constants_1.OBJECTION_MODULE_CONNECTION_TOKEN}_${model.tableName || model.name}`;
}
exports.getObjectionModelToken = getObjectionModelToken;
function createObjectionConnection(options) {
    const { config } = options;
    const BaseModel = options.Model || objection_1.Model;
    const knex = Knex(config);
    BaseModel.knex(knex);
    return knex;
}
exports.createObjectionConnection = createObjectionConnection;
